/*Smart Plant Tracker
 
 * The circuit is lighting the planet in the best light possible according to the enviroment light/
 * The circuit is managed with an remote app on your smartphone.
 * The circuit is tracking the tempreture around and keeps you informed.
 * There is a power button that enables the functionality
 * The circuit shows an alert Light when the tempreture is not correct.
 

  The circuit:
  input : Phone turn on/off button
  output: lights, phone screen.

  

  Video link: a link to a video showing your work.
  Created By:
  Eitan Frimerman 
  Noy Mizrahi 
*/ 

#define BLYNK_PRINT SerialUSB
#define BLYNK_DEBUG SerialUSB

// blynk-cloud.com/G0q_J0Mzr5PCPhJ3Lpb00sUzx7-UX_db/update/V0?value=50

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = "CHANGE TO USERS";
char ssid[] = "CHANGE TO USERS";
char pass[] = "CHANGE TO USERS";


#define EspSerial Serial1
#define ESP8266_BAUD 9600

ESP8266 wifi(&EspSerial);

long last_sent = 0;


float prevAcc = -9999; //some value that flags the default one.
bool isPowerOn = false;
float rValue = 0;
float gValue = 0;
float bValue = 0;
int currentImage = 0;
int numOfImages = 2; 
void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
}

void loop() {
  Blynk.run();
  updateTemp();
  manageLights();
  }

void updateTemp(){ //flashing lights.
  float tempValue = 0;
    if(isPowerOn) //check if power on!
    {
      tempValue = CircuitPlayground.temperature();
      if(tempValue > 40)
    {
      Blynk.setProperty(V3, "color", "#FF0000");
      WidgetLED led3(V3);
      led3.on();
    }
    else
    {
      WidgetLED led3(V3);
      led3.off();
    }
    }
    else // if power off turn lioghts off
    {
     tempValue = 0;
     WidgetLED led3(V3);
     led3.off();
    }
    Blynk.virtualWrite(V1, tempValue);
    
    
}

void manageLights() // switching images according to the button left/right
{
  float lightPower = 255 - CircuitPlayground.lightSensor();
  if(CircuitPlayground.lightSensor() > 100)
  {
    lightPower = 0;
    }
  if(isPowerOn)
  {
    for(int i = 0 ; i <= 9; i++) {
    CircuitPlayground.setPixelColor(i, 0, lightPower, 0);
    }
  }
  
  else
  {
      for(int i = 0 ; i <= 9; i++) {
    CircuitPlayground.setPixelColor(i, 0, 0, 0);
  }
  }
}
BLYNK_WRITE(V0) {
  int pinValue = param.asInt(); // assigning incoming value from pin V0 to a variable
  isPowerOn = pinValue;
  }
BLYNK_WRITE(V1) {
  int pinValue = param.asInt(); // assigning incoming value from pin V0 to a variable
  }
